/[gentoo-x86]/eclass/eutils.eclass
Gentoo

Diff of /eclass/eutils.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.162 Revision 1.223
1# Copyright 1999-2005 Gentoo Foundation 1# Copyright 1999-2005 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.162 2005/03/23 12:46:11 ka0ttic Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.223 2006/02/15 23:40:16 flameeyes Exp $
4# 4#
5# Author: Martin Schlemmer <azarah@gentoo.org> 5# Author: Martin Schlemmer <azarah@gentoo.org>
6# 6#
7# This eclass is for general purpose functions that most ebuilds 7# This eclass is for general purpose functions that most ebuilds
8# have to implement themselves. 8# have to implement themselves.
9# 9#
10# NB: If you add anything, please comment it! 10# NB: If you add anything, please comment it!
11 11
12inherit multilib 12inherit multilib portability
13ECLASS=eutils
14INHERITED="$INHERITED $ECLASS"
15 13
16DEPEND="!bootstrap? ( sys-devel/patch )" 14DEPEND="!bootstrap? ( sys-devel/patch )"
15# sys-apps/shadow is needed for useradd, etc, bug #94745.
17 16
18DESCRIPTION="Based on the ${ECLASS} eclass" 17DESCRIPTION="Based on the ${ECLASS} eclass"
19
20# ecpu_check
21# Usage:
22#
23# ecpu_check array_of_cpu_flags
24#
25# array_of_cpu_flags - An array of cpu flags to check against USE flags
26#
27# Checks user USE related cpu flags against /proc/cpuinfo. If user enables a
28# cpu flag that is not supported in their processor flags, it will warn the
29# user if CROSSCOMPILE is not set to 1 ( because cross compile users are
30# obviously using different cpu flags than their own cpu ). Examples:
31#
32# CPU_FLAGS=(mmx mmx2 sse sse2)
33# ecpu_check CPU_FLAGS
34# Chris White <chriswhite@gentoo.org> (03 Feb 2005)
35
36ecpu_check() {
37 # Think about changing below to: if [ "${CROSSCOMPILE}" -ne 1 -a -e "/proc/cpuinfo" ]
38 # and dropping the else if you do not plan on adding anything to that
39 # empty block ....
40 # PS: also try to add some quoting, and consider rather using ${foo} than $foo ...
41 if [ "${CROSSCOMPILE}" != "1" -a -e "/proc/cpuinfo" ]
42 then
43 CPU_FLAGS=${1}
44 USER_CPU=`grep "flags" /proc/cpuinfo`
45
46 for flags in `seq 1 ${#CPU_FLAGS[@]}`
47 do
48 if has ${CPU_FLAGS[${flags} - 1]} ${USER_CPU} && ! has ${CPU_FLAGS[${flags} - 1]} ${USE}
49 then
50 ewarn "Your system is ${CPU_FLAGS[${flags} - 1]} capable but you don't have it enabled!"
51 ewarn "You might be cross compiling (in this case set CROSSCOMPILE to 1 to disable this warning."
52 fi
53
54 if ! has ${CPU_FLAGS[${flags} - 1]} ${USER_CPU} && has ${CPU_FLAGS[${flags} -1]} ${USE}
55 then
56 ewarn "You have ${CPU_FLAGS[${flags} - 1]} support enabled but your processor doesn't"
57 ewarn "Seem to support it! You might be cross compiling or do not have /proc filesystem"
58 ewarn "enabled. If either is the case, set CROSSCOMPILE to 1 to disable this warning."
59 fi
60 done
61 fi
62}
63 18
64# Wait for the supplied number of seconds. If no argument is supplied, defaults 19# Wait for the supplied number of seconds. If no argument is supplied, defaults
65# to five seconds. If the EPAUSE_IGNORE env var is set, don't wait. If we're not 20# to five seconds. If the EPAUSE_IGNORE env var is set, don't wait. If we're not
66# outputting to a terminal, don't wait. For compatability purposes, the argument 21# outputting to a terminal, don't wait. For compatability purposes, the argument
67# must be an integer greater than zero. 22# must be an integer greater than zero.
105# to point to the latest version of the library present. 60# to point to the latest version of the library present.
106# 61#
107# <azarah@gentoo.org> (26 Oct 2002) 62# <azarah@gentoo.org> (26 Oct 2002)
108# 63#
109gen_usr_ldscript() { 64gen_usr_ldscript() {
110 local libdir="$(get_libdir)" 65 local lib libdir=$(get_libdir)
111 # Just make sure it exists 66 # Just make sure it exists
112 dodir /usr/${libdir} 67 dodir /usr/${libdir}
113 68
114 while [[ $# -gt 0 ]] ; do 69 for lib in "${@}" ; do
115 cat > "${D}/usr/${libdir}/$1" <<-END_LDSCRIPT 70 cat > "${D}/usr/${libdir}/${lib}" <<-END_LDSCRIPT
116 /* GNU ld script 71 /* GNU ld script
117 Since Gentoo has critical dynamic libraries 72 Since Gentoo has critical dynamic libraries
118 in /lib, and the static versions in /usr/lib, 73 in /lib, and the static versions in /usr/lib,
119 we need to have a "fake" dynamic lib in /usr/lib, 74 we need to have a "fake" dynamic lib in /usr/lib,
120 otherwise we run into linking problems. 75 otherwise we run into linking problems.
121 76
122 See bug http://bugs.gentoo.org/4411 for more info. 77 See bug http://bugs.gentoo.org/4411 for more info.
123 */ 78 */
124 GROUP ( /${libdir}/$1 ) 79 GROUP ( /${libdir}/${lib} )
125 END_LDSCRIPT 80 END_LDSCRIPT
126 fperms a+x "/usr/${libdir}/$1" 81 fperms a+x "/usr/${libdir}/${lib}" || die "could not change perms on ${lib}"
127 shift
128 done 82 done
129} 83}
130 84
131# Simple function to draw a line consisting of '=' the same length as $*
132#
133# <azarah@gentoo.org> (11 Nov 2002)
134#
135draw_line() {
136 local i=0
137 local str_length=""
138
139 # Handle calls that do not have args, or wc not being installed ...
140 if [ -z "$1" -o ! -x "$(which wc 2>/dev/null)" ]
141 then
142 echo "==============================================================="
143 return 0
144 fi
145
146 # Get the length of $*
147 str_length="$(echo -n "$*" | wc -m)"
148
149 while [ "$i" -lt "${str_length}" ]
150 do
151 echo -n "="
152
153 i=$((i + 1))
154 done
155
156 echo
157
158 return 0
159}
160 85
161# Default directory where patches are located 86# Default directory where patches are located
162EPATCH_SOURCE="${WORKDIR}/patch" 87EPATCH_SOURCE="${WORKDIR}/patch"
163# Default extension for patches 88# Default extension for patches
164EPATCH_SUFFIX="patch.bz2" 89EPATCH_SUFFIX="patch.bz2"
165# Default options for patch 90# Default options for patch
166# Set -g0 to keep RCS, ClearCase, Perforce and SCCS happy. Bug #24571 91# Set -g0 to keep RCS, ClearCase, Perforce and SCCS happy. Bug #24571
167EPATCH_OPTS="-g0" 92# Set --no-backup-if-mismatch so we don't leave '.orig' files behind.
93EPATCH_OPTS="-g0 --no-backup-if-mismatch"
168# List of patches not to apply. Not this is only file names, 94# List of patches not to apply. Not this is only file names,
169# and not the full path .. 95# and not the full path ..
170EPATCH_EXCLUDE="" 96EPATCH_EXCLUDE=""
171# Change the printed message for a single patch. 97# Change the printed message for a single patch.
172EPATCH_SINGLE_MSG="" 98EPATCH_SINGLE_MSG=""
99# Change the printed message for multiple patches.
100EPATCH_MULTI_MSG="Applying various patches (bugfixes/updates) ..."
173# Force applying bulk patches even if not following the style: 101# Force applying bulk patches even if not following the style:
174# 102#
175# ??_${ARCH}_foo.${EPATCH_SUFFIX} 103# ??_${ARCH}_foo.${EPATCH_SUFFIX}
176# 104#
177EPATCH_FORCE="no" 105EPATCH_FORCE="no"
208# hand its a directory, it will set EPATCH_SOURCE to this. 136# hand its a directory, it will set EPATCH_SOURCE to this.
209# 137#
210# <azarah@gentoo.org> (10 Nov 2002) 138# <azarah@gentoo.org> (10 Nov 2002)
211# 139#
212epatch() { 140epatch() {
141 _epatch_draw_line() {
142 local i=0 str_length="" str_out=""
143
144 # Handle calls that do not have args, or wc not being installed ...
145 if [[ -z $1 ]] || ! type -p wc >/dev/null ; then
146 str_length=65
147 else
148 str_length=$(echo -n "$*" | wc -m)
149 fi
150
151 while ((i++ < ${str_length})) ; do
152 str_out="${str_out}="
153 done
154 echo ${str_out}
155
156 return 0
157 }
158 _epatch_assert() { local _pipestatus=${PIPESTATUS[*]}; [[ ${_pipestatus// /} -eq 0 ]] ; }
213 local PIPE_CMD="" 159 local PIPE_CMD=""
214 local STDERR_TARGET="${T}/$$.out" 160 local STDERR_TARGET="${T}/$$.out"
215 local PATCH_TARGET="${T}/$$.patch" 161 local PATCH_TARGET="${T}/$$.patch"
216 local PATCH_SUFFIX="" 162 local PATCH_SUFFIX=""
217 local SINGLE_PATCH="no" 163 local SINGLE_PATCH="no"
218 local x="" 164 local x=""
219 165
166 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402
167
220 if [ "$#" -gt 1 ] 168 if [ "$#" -gt 1 ]
221 then 169 then
222 local m="" 170 local m=""
223 einfo "${#} patches to apply ..."
224 for m in "$@" ; do 171 for m in "$@" ; do
225 epatch "${m}" 172 epatch "${m}"
226 done 173 done
227 return 0 174 return 0
228 fi 175 fi
282 ;; 229 ;;
283 esac 230 esac
284 231
285 if [ "${SINGLE_PATCH}" = "no" ] 232 if [ "${SINGLE_PATCH}" = "no" ]
286 then 233 then
287 einfo "Applying various patches (bugfixes/updates) ..." 234 einfo "${EPATCH_MULTI_MSG}"
288 fi 235 fi
289 for x in ${EPATCH_SOURCE} 236 for x in ${EPATCH_SOURCE}
290 do 237 do
291 # New ARCH dependant patch naming scheme ... 238 # New ARCH dependant patch naming scheme ...
292 # 239 #
293 # ???_arch_foo.patch 240 # ???_arch_foo.patch
294 # 241 #
295 if [ -f ${x} ] && \ 242 if [ -f ${x} ] && \
296 ([ "${SINGLE_PATCH}" = "yes" -o "${x/_all_}" != "${x}" -o "`eval echo \$\{x/_${ARCH}_\}`" != "${x}" ] || \ 243 ([ "${SINGLE_PATCH}" = "yes" -o "${x/_all_}" != "${x}" -o "${x/_${ARCH}_}" != "${x}" ] || \
297 [ "${EPATCH_FORCE}" = "yes" ]) 244 [ "${EPATCH_FORCE}" = "yes" ])
298 then 245 then
299 local count=0 246 local count=0
300 local popts="${EPATCH_OPTS}" 247 local popts="${EPATCH_OPTS}"
301 local patchname=${x##*/} 248 local patchname=${x##*/}
325 272
326 # Allow for prefix to differ ... im lazy, so shoot me :/ 273 # Allow for prefix to differ ... im lazy, so shoot me :/
327 while [ "${count}" -lt 5 ] 274 while [ "${count}" -lt 5 ]
328 do 275 do
329 # Generate some useful debug info ... 276 # Generate some useful debug info ...
330 draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 277 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
331 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 278 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
332 279
333 if [ "${PATCH_SUFFIX}" != "patch" ] 280 if [ "${PATCH_SUFFIX}" != "patch" ]
334 then 281 then
335 echo -n "PIPE_COMMAND: " >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 282 echo -n "PIPE_COMMAND: " >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
340 287
341 echo -n "PATCH COMMAND: " >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 288 echo -n "PATCH COMMAND: " >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
342 echo "patch -p${count} ${popts} < ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 289 echo "patch -p${count} ${popts} < ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
343 290
344 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 291 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
345 draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 292 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
346 293
347 if [ "${PATCH_SUFFIX}" != "patch" ] 294 if [ "${PATCH_SUFFIX}" != "patch" ]
348 then 295 then
349 if ! (${PIPE_CMD} ${x} > ${PATCH_TARGET}) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1 296 if ! (${PIPE_CMD} ${x} > ${PATCH_TARGET}) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1
350 then 297 then
354 count=5 301 count=5
355 break 302 break
356 fi 303 fi
357 fi 304 fi
358 305
359 if (cat ${PATCH_TARGET} | patch -p${count} ${popts} --dry-run -f) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1 306 if (cat ${PATCH_TARGET} | patch -p${count} ${popts} --dry-run -f ; _epatch_assert) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1
360 then 307 then
361 draw_line "***** ${patchname} *****" > ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real 308 _epatch_draw_line "***** ${patchname} *****" > ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
362 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real 309 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
363 echo "ACTUALLY APPLYING ${patchname} ..." >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real 310 echo "ACTUALLY APPLYING ${patchname} ..." >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
364 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real 311 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
365 draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real 312 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
366 313
367 cat ${PATCH_TARGET} | patch -p${count} ${popts} >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real 2>&1 314 cat ${PATCH_TARGET} | patch -p${count} ${popts} >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real 2>&1
315 _epatch_assert
368 316
369 if [ "$?" -ne 0 ] 317 if [ "$?" -ne 0 ]
370 then 318 then
371 cat ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 319 cat ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
372 echo 320 echo
411 then 359 then
412 einfo "Done with patching" 360 einfo "Done with patching"
413 fi 361 fi
414} 362}
415 363
416# This function return true if we are using the NPTL pthreads
417# implementation.
418#
419# <azarah@gentoo.org> (06 March 2003)
420#
421have_NPTL() {
422 cat > ${T}/test-nptl.c <<-"END"
423 #define _XOPEN_SOURCE
424 #include <unistd.h>
425 #include <stdio.h>
426
427 int main()
428 {
429 char buf[255];
430 char *str = buf;
431
432 confstr(_CS_GNU_LIBPTHREAD_VERSION, str, 255);
433 if (NULL != str) {
434 printf("%s\n", str);
435 if (NULL != strstr(str, "NPTL"))
436 return 0;
437 }
438
439 return 1;
440 }
441 END
442
443 einfon "Checking for _CS_GNU_LIBPTHREAD_VERSION support in glibc ..."
444 if gcc -o ${T}/nptl ${T}/test-nptl.c &> /dev/null
445 then
446 echo "yes"
447 einfon "Checking what PTHREADS implementation we have ..."
448 if ${T}/nptl
449 then
450 return 0
451 else
452 return 1
453 fi
454 else
455 echo "no"
456 fi
457
458 return 1
459}
460
461# This function check how many cpu's are present, and then set
462# -j in MAKEOPTS accordingly.
463#
464# Thanks to nall <nall@gentoo.org> for this.
465#
466get_number_of_jobs() {
467 local jobs=0
468
469 if [ ! -r /proc/cpuinfo ]
470 then
471 return 1
472 fi
473
474 # This bit is from H?kan Wessberg <nacka-gentoo@refug.org>, bug #13565.
475 if [ "`egrep "^[[:space:]]*MAKEOPTS=" /etc/make.conf | wc -l`" -gt 0 ]
476 then
477 ADMINOPTS="`egrep "^[[:space:]]*MAKEOPTS=" /etc/make.conf | cut -d= -f2 | sed 's/\"//g'`"
478 ADMINPARAM="`echo ${ADMINOPTS} | gawk '{match($0, /-j *[0-9]*/, opt); print opt[0]}'`"
479 ADMINPARAM="${ADMINPARAM/-j}"
480 fi
481
482 export MAKEOPTS="`echo ${MAKEOPTS} | sed -e 's:-j *[0-9]*::g'`"
483
484 if [ "${ARCH}" = "amd64" -o "${ARCH}" = "x86" -o "${ARCH}" = "hppa" -o \
485 "${ARCH}" = "arm" -o "${ARCH}" = "mips" -o "${ARCH}" = "ia64" ]
486 then
487 # these archs will always have "[Pp]rocessor"
488 jobs="$((`grep -c ^[Pp]rocessor /proc/cpuinfo` * 2))"
489
490 elif [ "${ARCH}" = "sparc" -o "${ARCH}" = "sparc64" ]
491 then
492 # sparc always has "ncpus active"
493 jobs="$((`grep "^ncpus active" /proc/cpuinfo | sed -e "s/^.*: //"` * 2))"
494
495 elif [ "${ARCH}" = "alpha" ]
496 then
497 # alpha has "cpus active", but only when compiled with SMP
498 if [ "`grep -c "^cpus active" /proc/cpuinfo`" -eq 1 ]
499 then
500 jobs="$((`grep "^cpus active" /proc/cpuinfo | sed -e "s/^.*: //"` * 2))"
501 else
502 jobs=2
503 fi
504
505 elif [ "${ARCH}" = "ppc" -o "${ARCH}" = "ppc64" ]
506 then
507 # ppc has "processor", but only when compiled with SMP
508 if [ "`grep -c "^processor" /proc/cpuinfo`" -eq 1 ]
509 then
510 jobs="$((`grep -c ^processor /proc/cpuinfo` * 2))"
511 else
512 jobs=2
513 fi
514 elif [ "${ARCH}" = "s390" ]
515 then
516 # s390 has "# processors : "
517 jobs="$((`grep "^\# processors" /proc/cpuinfo | sed -e "s/^.*: //"` * 2))"
518 else
519 jobs="$((`grep -c ^cpu /proc/cpuinfo` * 2))"
520 die "Unknown ARCH -- ${ARCH}!"
521 fi
522
523 # Make sure the number is valid ...
524 if [ "${jobs}" -lt 1 ]
525 then
526 jobs=1
527 fi
528
529 if [ -n "${ADMINPARAM}" ]
530 then
531 if [ "${jobs}" -gt "${ADMINPARAM}" ]
532 then
533 einfo "Setting make jobs to \"-j${ADMINPARAM}\" to ensure successful merge ..."
534 export MAKEOPTS="${MAKEOPTS} -j${ADMINPARAM}"
535 else
536 einfo "Setting make jobs to \"-j${jobs}\" to ensure successful merge ..."
537 export MAKEOPTS="${MAKEOPTS} -j${jobs}"
538 fi
539 fi
540}
541
542# Cheap replacement for when debianutils (and thus mktemp) 364# Cheap replacement for when debianutils (and thus mktemp)
543# does not exist on the users system 365# does not exist on the users system
544# vapier@gentoo.org 366# vapier@gentoo.org
545# 367#
546# Takes just 1 optional parameter (the directory to create tmpfile in) 368# Takes just 1 optional parameter (the directory to create tmpfile in)
547emktemp() { 369emktemp() {
548 local exe="touch" 370 local exe="touch"
549 [ "$1" == "-d" ] && exe="mkdir" && shift 371 [[ $1 == -d ]] && exe="mkdir" && shift
550 local topdir="$1" 372 local topdir=$1
551 373
552 if [ -z "${topdir}" ] 374 if [[ -z ${topdir} ]] ; then
553 then
554 [ -z "${T}" ] \ 375 [[ -z ${T} ]] \
555 && topdir="/tmp" \ 376 && topdir="/tmp" \
556 || topdir="${T}" 377 || topdir=${T}
557 fi 378 fi
558 379
559 if [ -z "$(type -p mktemp)" ] 380 if [[ -z $(type -p mktemp) ]] ; then
560 then
561 local tmp=/ 381 local tmp=/
562 while [ -e "${tmp}" ] ; do 382 while [[ -e ${tmp} ]] ; do
563 tmp="${topdir}/tmp.${RANDOM}.${RANDOM}.${RANDOM}" 383 tmp=${topdir}/tmp.${RANDOM}.${RANDOM}.${RANDOM}
564 done 384 done
565 ${exe} "${tmp}" 385 ${exe} "${tmp}" || ${exe} -p "${tmp}"
566 echo "${tmp}" 386 echo "${tmp}"
567 else 387 else
568 [ "${exe}" == "touch" ] \ 388 if [[ ${exe} == "touch" ]] ; then
389 [[ ${USERLAND} == "GNU" ]] \
569 && exe="-p" \ 390 && exe="-p" \
391 || exe="-t"
392 else
393 [[ ${USERLAND} == "GNU" ]] \
394 && exe="-d" \
570 || exe="-d" 395 || exe="-dt"
571 mktemp ${exe} "${topdir}" 396 fi
397 TMPDIR="${topdir}" mktemp ${exe} tmp
572 fi 398 fi
573} 399}
574 400
575# Small wrapper for getent (Linux), nidump (Mac OS X), 401# Small wrapper for getent (Linux), nidump (Mac OS X),
576# and pw (FreeBSD) used in enewuser()/enewgroup() 402# and pw (FreeBSD) used in enewuser()/enewgroup()
577# Joe Jezak <josejx@gmail.com> and usata@gentoo.org 403# Joe Jezak <josejx@gmail.com> and usata@gentoo.org
578# FBSD stuff: Aaron Walker <ka0ttic@gentoo.org> 404# FBSD stuff: Aaron Walker <ka0ttic@gentoo.org>
579# 405#
580# egetent(database, key) 406# egetent(database, key)
581egetent() { 407egetent() {
582 if useq ppc-macos ; then 408 case ${CHOST} in
409 *-darwin*)
583 case "$2" in 410 case "$2" in
584 *[!0-9]*) # Non numeric 411 *[!0-9]*) # Non numeric
585 nidump $1 . | awk -F":" "{ if (\$1 ~ /^$2$/) {print \$0;exit;} }" 412 nidump $1 . | awk -F":" "{ if (\$1 ~ /^$2$/) {print \$0;exit;} }"
586 ;; 413 ;;
587 *) # Numeric 414 *) # Numeric
588 nidump $1 . | awk -F":" "{ if (\$3 == $2) {print \$0;exit;} }" 415 nidump $1 . | awk -F":" "{ if (\$3 == $2) {print \$0;exit;} }"
589 ;; 416 ;;
590 esac 417 esac
591 elif useq x86-fbsd ; then 418 ;;
592 local action 419 *-freebsd*|*-dragonfly*)
593 if [ "$1" == "passwd" ] 420 local opts action="user"
594 then 421 [[ $1 == "passwd" ]] || action="group"
595 action="user" 422
596 else 423 # lookup by uid/gid
597 action="group" 424 if [[ $2 == [[:digit:]]* ]] ; then
425 [[ ${action} == "user" ]] && opts="-u" || opts="-g"
598 fi 426 fi
427
599 pw show "${action}" "$2" -q 428 pw show ${action} ${opts} "$2" -q
600 else 429 ;;
430 *-netbsd*|*-openbsd*)
431 grep "$2:\*:" /etc/$1
432 ;;
433 *)
601 which nscd >& /dev/null && nscd -i "$1" 434 type -p nscd >& /dev/null && nscd -i "$1"
602 getent "$1" "$2" 435 getent "$1" "$2"
603 fi 436 ;;
437 esac
604} 438}
605 439
606# Simplify/standardize adding users to the system 440# Simplify/standardize adding users to the system
607# vapier@gentoo.org 441# vapier@gentoo.org
608# 442#
616# homedir: /dev/null 450# homedir: /dev/null
617# groups: none 451# groups: none
618# extra: comment of 'added by portage for ${PN}' 452# extra: comment of 'added by portage for ${PN}'
619enewuser() { 453enewuser() {
620 # get the username 454 # get the username
621 local euser="$1"; shift 455 local euser=$1; shift
622 if [ -z "${euser}" ] 456 if [[ -z ${euser} ]] ; then
623 then
624 eerror "No username specified !" 457 eerror "No username specified !"
625 die "Cannot call enewuser without a username" 458 die "Cannot call enewuser without a username"
626 fi 459 fi
627 460
628 # lets see if the username already exists 461 # lets see if the username already exists
629 if [ "${euser}" == "`egetent passwd \"${euser}\" | cut -d: -f1`" ] 462 if [[ ${euser} == $(egetent passwd "${euser}" | cut -d: -f1) ]] ; then
630 then
631 return 0 463 return 0
632 fi 464 fi
633 einfo "Adding user '${euser}' to your system ..." 465 einfo "Adding user '${euser}' to your system ..."
634 466
635 # options to pass to useradd 467 # options to pass to useradd
636 local opts= 468 local opts=
637 469
638 # handle uid 470 # handle uid
639 local euid="$1"; shift 471 local euid=$1; shift
640 if [ ! -z "${euid}" ] && [ "${euid}" != "-1" ] 472 if [[ ! -z ${euid} ]] && [[ ${euid} != "-1" ]] ; then
641 then
642 if [ "${euid}" -gt 0 ] 473 if [[ ${euid} -gt 0 ]] ; then
643 then
644 if [ ! -z "`egetent passwd ${euid}`" ] 474 if [[ ! -z $(egetent passwd ${euid}) ]] ; then
645 then
646 euid="next" 475 euid="next"
647 fi 476 fi
648 else 477 else
649 eerror "Userid given but is not greater than 0 !" 478 eerror "Userid given but is not greater than 0 !"
650 die "${euid} is not a valid UID" 479 die "${euid} is not a valid UID"
651 fi 480 fi
652 else 481 else
653 euid="next" 482 euid="next"
654 fi 483 fi
655 if [ "${euid}" == "next" ] 484 if [[ ${euid} == "next" ]] ; then
656 then 485 for euid in $(seq 101 999) ; do
657 local pwrange
658 if [ "${USERLAND}" == "BSD" ] ; then
659 pwrange="`jot 898 101`"
660 else
661 pwrange="`seq 101 999`"
662 fi
663 for euid in ${pwrange} ; do
664 [ -z "`egetent passwd ${euid}`" ] && break 486 [[ -z $(egetent passwd ${euid}) ]] && break
665 done 487 done
666 fi 488 fi
667 opts="${opts} -u ${euid}" 489 opts="${opts} -u ${euid}"
668 einfo " - Userid: ${euid}" 490 einfo " - Userid: ${euid}"
669 491
670 # handle shell 492 # handle shell
671 local eshell="$1"; shift 493 local eshell=$1; shift
672 if [ ! -z "${eshell}" ] && [ "${eshell}" != "-1" ] 494 if [[ ! -z ${eshell} ]] && [[ ${eshell} != "-1" ]] ; then
673 then 495 if [[ ! -e ${ROOT}${eshell} ]] ; then
674 if [ ! -e "${eshell}" ]
675 then
676 eerror "A shell was specified but it does not exist !" 496 eerror "A shell was specified but it does not exist !"
677 die "${eshell} does not exist" 497 die "${eshell} does not exist in ${ROOT}"
678 fi 498 fi
679 else 499 if [[ ${eshell} == */false || ${eshell} == */nologin ]] ; then
680 if [ "${USERLAND}" == "BSD" ] 500 eerror "Do not specify ${eshell} yourself, use -1"
681 then 501 die "Pass '-1' as the shell parameter"
682 eshell="/usr/bin/false" 502 fi
683 else 503 else
684 eshell="/bin/false" 504 for shell in /sbin/nologin /usr/sbin/nologin /bin/false /usr/bin/false /dev/null ; do
505 [[ -x ${ROOT}${shell} ]] && break
506 done
507
508 if [[ ${shell} == "/dev/null" ]] ; then
509 eerror "Unable to identify the shell to use"
510 die "Unable to identify the shell to use"
685 fi 511 fi
512
513 eshell=${shell}
686 fi 514 fi
687 einfo " - Shell: ${eshell}" 515 einfo " - Shell: ${eshell}"
688 opts="${opts} -s ${eshell}" 516 opts="${opts} -s ${eshell}"
689 517
690 # handle homedir 518 # handle homedir
691 local ehome="$1"; shift 519 local ehome=$1; shift
692 if [ -z "${ehome}" ] && [ "${eshell}" != "-1" ] 520 if [[ -z ${ehome} ]] || [[ ${ehome} == "-1" ]] ; then
693 then
694 ehome="/dev/null" 521 ehome="/dev/null"
695 fi 522 fi
696 einfo " - Home: ${ehome}" 523 einfo " - Home: ${ehome}"
697 opts="${opts} -d ${ehome}" 524 opts="${opts} -d ${ehome}"
698 525
699 # handle groups 526 # handle groups
700 local egroups="$1"; shift 527 local egroups=$1; shift
701 if [ ! -z "${egroups}" ] 528 if [[ ! -z ${egroups} ]] ; then
702 then
703 local oldifs="${IFS}" 529 local oldifs=${IFS}
704 local defgroup="" exgroups="" 530 local defgroup="" exgroups=""
705 531
706 export IFS="," 532 export IFS=","
707 for g in ${egroups} 533 for g in ${egroups} ; do
708 do
709 export IFS="${oldifs}" 534 export IFS=${oldifs}
710 if [ -z "`egetent group \"${g}\"`" ] 535 if [[ -z $(egetent group "${g}") ]] ; then
711 then
712 eerror "You must add group ${g} to the system first" 536 eerror "You must add group ${g} to the system first"
713 die "${g} is not a valid GID" 537 die "${g} is not a valid GID"
714 fi 538 fi
715 if [ -z "${defgroup}" ] 539 if [[ -z ${defgroup} ]] ; then
716 then
717 defgroup="${g}" 540 defgroup=${g}
718 else 541 else
719 exgroups="${exgroups},${g}" 542 exgroups="${exgroups},${g}"
720 fi 543 fi
721 export IFS="," 544 export IFS=","
722 done 545 done
723 export IFS="${oldifs}" 546 export IFS=${oldifs}
724 547
725 opts="${opts} -g ${defgroup}" 548 opts="${opts} -g ${defgroup}"
726 if [ ! -z "${exgroups}" ] 549 if [[ ! -z ${exgroups} ]] ; then
727 then
728 opts="${opts} -G ${exgroups:1}" 550 opts="${opts} -G ${exgroups:1}"
729 fi 551 fi
730 else 552 else
731 egroups="(none)" 553 egroups="(none)"
732 fi 554 fi
733 einfo " - Groups: ${egroups}" 555 einfo " - Groups: ${egroups}"
734 556
735 # handle extra and add the user 557 # handle extra and add the user
736 local eextra="$@"
737 local oldsandbox="${SANDBOX_ON}" 558 local oldsandbox=${SANDBOX_ON}
738 export SANDBOX_ON="0" 559 export SANDBOX_ON="0"
739 if useq ppc-macos 560 case ${CHOST} in
740 then 561 *-darwin*)
741 ### Make the user 562 ### Make the user
742 if [ -z "${eextra}" ] 563 if [[ -z $@ ]] ; then
743 then
744 dscl . create /users/${euser} uid ${euid} 564 dscl . create /users/${euser} uid ${euid}
745 dscl . create /users/${euser} shell ${eshell} 565 dscl . create /users/${euser} shell ${eshell}
746 dscl . create /users/${euser} home ${ehome} 566 dscl . create /users/${euser} home ${ehome}
747 dscl . create /users/${euser} realname "added by portage for ${PN}" 567 dscl . create /users/${euser} realname "added by portage for ${PN}"
748 ### Add the user to the groups specified 568 ### Add the user to the groups specified
749 local oldifs="${IFS}" 569 local oldifs=${IFS}
750 export IFS="," 570 export IFS=","
751 for g in ${egroups} 571 for g in ${egroups} ; do
752 do
753 dscl . merge /groups/${g} users ${euser} 572 dscl . merge /groups/${g} users ${euser}
754 done 573 done
755 export IFS="${oldifs}" 574 export IFS=${oldifs}
756 else 575 else
757 einfo "Extra options are not supported on macos yet" 576 einfo "Extra options are not supported on Darwin yet"
758 einfo "Please report the ebuild along with the info below" 577 einfo "Please report the ebuild along with the info below"
759 einfo "eextra: ${eextra}" 578 einfo "eextra: $@"
760 die "Required function missing" 579 die "Required function missing"
761 fi 580 fi
762 elif use x86-fbsd ; then 581 ;;
763 if [ -z "${eextra}" ] 582 *-freebsd*|*-dragonfly*)
764 then 583 if [[ -z $@ ]] ; then
765 pw useradd ${euser} ${opts} \ 584 pw useradd ${euser} ${opts} \
766 -c "added by portage for ${PN}" \ 585 -c "added by portage for ${PN}" \
767 die "enewuser failed" 586 die "enewuser failed"
768 else 587 else
769 einfo " - Extra: ${eextra}" 588 einfo " - Extra: $@"
770 pw useradd ${euser} ${opts} \ 589 pw useradd ${euser} ${opts} \
771 -c ${eextra} || die "enewuser failed" 590 "$@" || die "enewuser failed"
772 fi 591 fi
592 ;;
593
594 *-netbsd*)
595 if [[ -z $@ ]] ; then
596 useradd ${opts} ${euser} || die "enewuser failed"
773 else 597 else
774 if [ -z "${eextra}" ] 598 einfo " - Extra: $@"
775 then 599 useradd ${opts} ${euser} "$@" || die "enewuser failed"
600 fi
601 ;;
602
603 *-openbsd*)
604 if [[ -z $@ ]] ; then
605 useradd -u ${euid} -s ${eshell} \
606 -d ${ehome} -c "Added by portage for ${PN}" \
607 -g ${egroups} ${euser} || die "enewuser failed"
608 else
609 einfo " - Extra: $@"
610 useradd -u ${euid} -s ${eshell} \
611 -d ${ehome} -c "Added by portage for ${PN}" \
612 -g ${egroups} ${euser} "$@" || die "enewuser failed"
613 fi
614 ;;
615
616 *)
617 if [[ -z $@ ]] ; then
776 useradd ${opts} ${euser} \ 618 useradd ${opts} ${euser} \
777 -c "added by portage for ${PN}" \ 619 -c "added by portage for ${PN}" \
778 || die "enewuser failed" 620 || die "enewuser failed"
779 else 621 else
780 einfo " - Extra: ${eextra}" 622 einfo " - Extra: $@"
781 useradd ${opts} ${euser} ${eextra} \ 623 useradd ${opts} ${euser} "$@" \
782 || die "enewuser failed" 624 || die "enewuser failed"
783 fi 625 fi
626 ;;
627 esac
628
629 if [[ ! -e ${ROOT}/${ehome} ]] ; then
630 einfo " - Creating ${ehome} in ${ROOT}"
631 mkdir -p "${ROOT}/${ehome}"
632 chown ${euser} "${ROOT}/${ehome}"
633 chmod 755 "${ROOT}/${ehome}"
784 fi 634 fi
635
785 export SANDBOX_ON="${oldsandbox}" 636 export SANDBOX_ON=${oldsandbox}
786
787 if [ ! -e "${ehome}" ] && [ ! -e "${D}/${ehome}" ]
788 then
789 einfo " - Creating ${ehome} in ${D}"
790 dodir ${ehome}
791 fowners ${euser} ${ehome}
792 fperms 755 ${ehome}
793 fi
794} 637}
795 638
796# Simplify/standardize adding groups to the system 639# Simplify/standardize adding groups to the system
797# vapier@gentoo.org 640# vapier@gentoo.org
798# 641#
827 then 670 then
828 if [ "${egid}" -gt 0 ] 671 if [ "${egid}" -gt 0 ]
829 then 672 then
830 if [ -z "`egetent group ${egid}`" ] 673 if [ -z "`egetent group ${egid}`" ]
831 then 674 then
832 if useq ppc-macos ; then 675 if [[ "${CHOST}" == *-darwin* ]]; then
833 opts="${opts} ${egid}" 676 opts="${opts} ${egid}"
834 else 677 else
835 opts="${opts} -g ${egid}" 678 opts="${opts} -g ${egid}"
836 fi 679 fi
837 else 680 else
851 opts="${opts} ${eextra}" 694 opts="${opts} ${eextra}"
852 695
853 # add the group 696 # add the group
854 local oldsandbox="${SANDBOX_ON}" 697 local oldsandbox="${SANDBOX_ON}"
855 export SANDBOX_ON="0" 698 export SANDBOX_ON="0"
856 if useq ppc-macos ; then 699 case ${CHOST} in
700 *-darwin*)
857 if [ ! -z "${eextra}" ]; 701 if [ ! -z "${eextra}" ];
858 then 702 then
859 einfo "Extra options are not supported on macos yet" 703 einfo "Extra options are not supported on Darwin/OS X yet"
860 einfo "Please report the ebuild along with the info below" 704 einfo "Please report the ebuild along with the info below"
861 einfo "eextra: ${eextra}" 705 einfo "eextra: ${eextra}"
862 die "Required function missing" 706 die "Required function missing"
863 fi 707 fi
864 708
865 # If we need the next available 709 # If we need the next available
866 case ${egid} in 710 case ${egid} in
867 *[!0-9]*) # Non numeric 711 *[!0-9]*) # Non numeric
868 for egid in `jot 898 101`; do 712 for egid in $(seq 101 999); do
869 [ -z "`egetent group ${egid}`" ] && break 713 [ -z "`egetent group ${egid}`" ] && break
870 done 714 done
871 esac 715 esac
872 dscl . create /groups/${egroup} gid ${egid} 716 dscl . create /groups/${egroup} gid ${egid}
873 dscl . create /groups/${egroup} passwd '*' 717 dscl . create /groups/${egroup} passwd '*'
874 elif use x86-fbsd ; then 718 ;;
719
720 *-freebsd*|*-dragonfly*)
875 case ${egid} in 721 case ${egid} in
876 *[!0-9]*) # Non numeric 722 *[!0-9]*) # Non numeric
877 for egid in `jot 898 101`; do 723 for egid in $(seq 101 999); do
878 [ -z "`egetent group ${egid}`" ] && break 724 [ -z "`egetent group ${egid}`" ] && break
879 done 725 done
880 esac 726 esac
881 pw groupadd ${egroup} -g ${egid} || die "enewgroup failed" 727 pw groupadd ${egroup} -g ${egid} || die "enewgroup failed"
882 else 728 ;;
729
730 *-netbsd*)
731 case ${egid} in
732 *[!0-9]*) # Non numeric
733 for egid in $(seq 101 999); do
734 [ -z "`egetent group ${egid}`" ] && break
735 done
736 esac
737 groupadd -g ${egid} ${egroup} || die "enewgroup failed"
738 ;;
739
740 *)
883 groupadd ${opts} ${egroup} || die "enewgroup failed" 741 groupadd ${opts} ${egroup} || die "enewgroup failed"
884 fi 742 ;;
743 esac
885 export SANDBOX_ON="${oldsandbox}" 744 export SANDBOX_ON="${oldsandbox}"
886} 745}
887 746
888# Simple script to replace 'dos2unix' binaries 747# Simple script to replace 'dos2unix' binaries
889# vapier@gentoo.org 748# vapier@gentoo.org
914# name: the name that will show up in the menu 773# name: the name that will show up in the menu
915# icon: give your little like a pretty little icon ... 774# icon: give your little like a pretty little icon ...
916# this can be relative (to /usr/share/pixmaps) or 775# this can be relative (to /usr/share/pixmaps) or
917# a full path to an icon 776# a full path to an icon
918# type: what kind of application is this ? for categories: 777# type: what kind of application is this ? for categories:
919# http://www.freedesktop.org/wiki/Standards_2fmenu_2dspec 778# http://www.freedesktop.org/Standards/desktop-entry-spec
920# path: if your app needs to startup in a specific dir 779# path: if your app needs to startup in a specific dir
921make_desktop_entry() { 780make_desktop_entry() {
922 [[ -z $1 ]] && eerror "make_desktop_entry: You must specify the executable" && return 1 781 [[ -z $1 ]] && eerror "make_desktop_entry: You must specify the executable" && return 1
923 782
924 local exec=${1} 783 local exec=${1}
950 dev) 809 dev)
951 type="Development" 810 type="Development"
952 ;; 811 ;;
953 812
954 games) 813 games)
955 [[ -z ${path} ]] && path=${GAMES_BINDIR}
956
957 case ${catmin} in 814 case ${catmin} in
958 action) type=ActionGame;; 815 action) type=ActionGame;;
959 arcade) type=ArcadeGame;; 816 arcade) type=ArcadeGame;;
960 board) type=BoardGame;; 817 board) type=BoardGame;;
961 kid) type=KidsGame;; 818 kid) type=KidsGame;;
1002 type="Network;${type}" 859 type="Network;${type}"
1003 ;; 860 ;;
1004 861
1005 sci) 862 sci)
1006 case ${catmin} in 863 case ${catmin} in
1007 astro*) type=Astronomoy;; 864 astro*) type=Astronomy;;
1008 bio*) type=Biology;; 865 bio*) type=Biology;;
1009 calc*) type=Calculator;; 866 calc*) type=Calculator;;
1010 chem*) type=Chemistry;; 867 chem*) type=Chemistry;;
1011 geo*) type=Geology;; 868 geo*) type=Geology;;
1012 math*) type=Math;; 869 math*) type=Math;;
1026 *) 883 *)
1027 type= 884 type=
1028 ;; 885 ;;
1029 esac 886 esac
1030 fi 887 fi
1031 888 if [ "${SLOT}" == "0" ] ; then
889 local desktop_name="${PN}"
890 else
891 local desktop_name="${PN}-${SLOT}"
892 fi
1032 local desktop=${T}/${exec%% *}-${P}.desktop 893 local desktop=${T}/${exec%% *}-${desktop_name}.desktop
1033 894
1034echo "[Desktop Entry] 895echo "[Desktop Entry]
1035Encoding=UTF-8 896Encoding=UTF-8
1036Version=0.9.2 897Version=0.9.2
1037Name=${name} 898Name=${name}
1040Exec=${exec} 901Exec=${exec}
1041Path=${path} 902Path=${path}
1042Icon=${icon} 903Icon=${icon}
1043Categories=Application;${type};" > "${desktop}" 904Categories=Application;${type};" > "${desktop}"
1044 905
906 (
907 # wrap the env here so that the 'insinto' call
908 # doesn't corrupt the env of the caller
1045 insinto /usr/share/applications 909 insinto /usr/share/applications
1046 doins "${desktop}" 910 doins "${desktop}"
1047 911 )
1048 return 0
1049} 912}
1050 913
1051# Make a GDM/KDM Session file 914# Make a GDM/KDM Session file
1052# 915#
1053# make_desktop_entry(<title>, <command>) 916# make_desktop_entry(<title>, <command>)
1054# title: File to execute to start the Window Manager 917# title: File to execute to start the Window Manager
1055# command: Name of the Window Manager 918# command: Name of the Window Manager
1056 919
1057make_session_desktop() { 920make_session_desktop() {
1058
1059 [ -z "$1" ] && eerror "make_session_desktop: You must specify the title" && return 1 921 [[ -z $1 ]] && eerror "make_session_desktop: You must specify the title" && return 1
1060 [ -z "$2" ] && eerror "make_session_desktop: You must specify the command" && return 1 922 [[ -z $2 ]] && eerror "make_session_desktop: You must specify the command" && return 1
1061 923
1062 local title="${1}" 924 local title=$1
1063 local command="${2}" 925 local command=$2
1064 local desktop="${T}/${wm}.desktop" 926 local desktop=${T}/${wm}.desktop
1065 927
1066echo "[Desktop Entry] 928echo "[Desktop Entry]
1067Encoding=UTF-8 929Encoding=UTF-8
1068Name=${title} 930Name=${title}
1069Comment=This session logs you into ${title} 931Comment=This session logs you into ${title}
1071TryExec=${command} 933TryExec=${command}
1072Type=Application" > "${desktop}" 934Type=Application" > "${desktop}"
1073 935
1074 insinto /usr/share/xsessions 936 insinto /usr/share/xsessions
1075 doins "${desktop}" 937 doins "${desktop}"
1076
1077 return 0
1078} 938}
1079 939
1080domenu() { 940domenu() {
1081 local i 941 local i j
1082 local j
1083 insinto /usr/share/applications 942 insinto /usr/share/applications
1084 for i in ${@} 943 for i in "$@" ; do
1085 do
1086 if [ -f "${i}" ]; 944 if [[ -f ${i} ]] ; then
1087 then
1088 doins ${i} 945 doins "${i}"
1089 elif [ -d "${i}" ]; 946 elif [[ -d ${i} ]] ; then
1090 then
1091 for j in ${i}/*.desktop 947 for j in "${i}"/*.desktop ; do
1092 do
1093 doins ${j} 948 doins "${j}"
1094 done 949 done
1095 fi 950 fi
1096 done 951 done
1097} 952}
953newmenu() {
954 insinto /usr/share/applications
955 newins "$1" "$2"
956}
1098 957
1099doicon() { 958doicon() {
1100 local i 959 local i j
1101 local j
1102 insinto /usr/share/pixmaps 960 insinto /usr/share/pixmaps
1103 for i in ${@} 961 for i in "$@" ; do
1104 do
1105 if [ -f "${i}" ]; 962 if [[ -f ${i} ]] ; then
1106 then
1107 doins ${i} 963 doins "${i}"
1108 elif [ -d "${i}" ]; 964 elif [[ -d ${i} ]] ; then
1109 then
1110 for j in ${i}/*.png 965 for j in "${i}"/*.png ; do
1111 do
1112 doins ${j} 966 doins "${j}"
1113 done 967 done
1114 fi 968 fi
1115 done 969 done
970}
971newicon() {
972 insinto /usr/share/pixmaps
973 newins "$1" "$2"
1116} 974}
1117 975
1118############################################################## 976##############################################################
1119# END: Handle .desktop files and menu entries # 977# END: Handle .desktop files and menu entries #
1120############################################################## 978##############################################################
1121 979
1122 980
1123# for internal use only (unpack_pdv and unpack_makeself) 981# for internal use only (unpack_pdv and unpack_makeself)
1124find_unpackable_file() { 982find_unpackable_file() {
1125 local src="$1" 983 local src=$1
1126 if [ -z "${src}" ] 984 if [[ -z ${src} ]] ; then
1127 then
1128 src="${DISTDIR}/${A}" 985 src=${DISTDIR}/${A}
1129 else 986 else
1130 if [ -e "${DISTDIR}/${src}" ] 987 if [[ -e ${DISTDIR}/${src} ]] ; then
1131 then
1132 src="${DISTDIR}/${src}" 988 src=${DISTDIR}/${src}
1133 elif [ -e "${PWD}/${src}" ] 989 elif [[ -e ${PWD}/${src} ]] ; then
1134 then
1135 src="${PWD}/${src}" 990 src=${PWD}/${src}
1136 elif [ -e "${src}" ] 991 elif [[ -e ${src} ]] ; then
1137 then
1138 src="${src}" 992 src=${src}
1139 fi
1140 fi 993 fi
1141 [ ! -e "${src}" ] && die "Could not find requested archive ${src}" 994 fi
995 [[ ! -e ${src} ]] && return 1
1142 echo "${src}" 996 echo "${src}"
1143} 997}
1144 998
1145# Unpack those pesky pdv generated files ... 999# Unpack those pesky pdv generated files ...
1146# They're self-unpacking programs with the binary package stuffed in 1000# They're self-unpacking programs with the binary package stuffed in
1161# lseek 1015# lseek
1162# root@vapier 0 pdv_unpack # strace -elseek ./hldsupdatetool.bin 1016# root@vapier 0 pdv_unpack # strace -elseek ./hldsupdatetool.bin
1163# lseek(3, -4, SEEK_END) = 2981250 1017# lseek(3, -4, SEEK_END) = 2981250
1164# thus we would pass in the value of '4' as the second parameter. 1018# thus we would pass in the value of '4' as the second parameter.
1165unpack_pdv() { 1019unpack_pdv() {
1166 local src="`find_unpackable_file $1`" 1020 local src=$(find_unpackable_file $1)
1167 local sizeoff_t="$2" 1021 local sizeoff_t=$2
1168 1022
1023 [[ -z ${src} ]] && die "Could not locate source for '$1'"
1169 [ -z "${sizeoff_t}" ] && die "No idea what off_t size was used for this pdv :(" 1024 [[ -z ${sizeoff_t} ]] && die "No idea what off_t size was used for this pdv :("
1170 1025
1171 local shrtsrc="`basename ${src}`" 1026 local shrtsrc=$(basename "${src}")
1172 echo ">>> Unpacking ${shrtsrc} to ${PWD}" 1027 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
1173 local metaskip=`tail -c ${sizeoff_t} ${src} | hexdump -e \"%i\"` 1028 local metaskip=`tail -c ${sizeoff_t} ${src} | hexdump -e \"%i\"`
1174 local tailskip=`tail -c $((${sizeoff_t}*2)) ${src} | head -c ${sizeoff_t} | hexdump -e \"%i\"` 1029 local tailskip=`tail -c $((${sizeoff_t}*2)) ${src} | head -c ${sizeoff_t} | hexdump -e \"%i\"`
1175 1030
1176 # grab metadata for debug reasons 1031 # grab metadata for debug reasons
1240# Usage: unpack_makeself [file to unpack] [offset] [tail|dd] 1095# Usage: unpack_makeself [file to unpack] [offset] [tail|dd]
1241# - If the file is not specified then unpack will utilize ${A}. 1096# - If the file is not specified then unpack will utilize ${A}.
1242# - If the offset is not specified then we will attempt to extract 1097# - If the offset is not specified then we will attempt to extract
1243# the proper offset from the script itself. 1098# the proper offset from the script itself.
1244unpack_makeself() { 1099unpack_makeself() {
1100 local src_input=${1:-${A}}
1245 local src="$(find_unpackable_file "$1")" 1101 local src=$(find_unpackable_file "${src_input}")
1246 local skip="$2" 1102 local skip=$2
1247 local exe="$3" 1103 local exe=$3
1248 1104
1105 [[ -z ${src} ]] && die "Could not locate source for '${src_input}'"
1106
1249 local shrtsrc="$(basename "${src}")" 1107 local shrtsrc=$(basename "${src}")
1250 echo ">>> Unpacking ${shrtsrc} to ${PWD}" 1108 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
1251 if [ -z "${skip}" ] 1109 if [[ -z ${skip} ]] ; then
1252 then
1253 local ver="`grep -a '#.*Makeself' ${src} | awk '{print $NF}'`" 1110 local ver=$(grep -a '#.*Makeself' "${src}" | awk '{print $NF}')
1254 local skip=0 1111 local skip=0
1255 exe=tail 1112 exe=tail
1256 case ${ver} in 1113 case ${ver} in
1257 1.5.*) # tested 1.5.{3,4,5} ... guessing 1.5.x series is same 1114 1.5.*) # tested 1.5.{3,4,5} ... guessing 1.5.x series is same
1258 skip=$(grep -a ^skip= "${src}" | cut -d= -f2) 1115 skip=$(grep -a ^skip= "${src}" | cut -d= -f2)
1270 ;; 1127 ;;
1271 2.1.3) 1128 2.1.3)
1272 skip=`grep -a ^offset= "${src}" | awk '{print $3}'` 1129 skip=`grep -a ^offset= "${src}" | awk '{print $3}'`
1273 let skip="skip + 1" 1130 let skip="skip + 1"
1274 ;; 1131 ;;
1275 2.1.4) 1132 2.1.4|2.1.5)
1276 skip=$(grep -a offset=.*head.*wc "${src}" | awk '{print $3}' | head -n 1) 1133 skip=$(grep -a offset=.*head.*wc "${src}" | awk '{print $3}' | head -n 1)
1277 skip=$(head -n ${skip} "${src}" | wc -c) 1134 skip=$(head -n ${skip} "${src}" | wc -c)
1278 exe="dd" 1135 exe="dd"
1279 ;; 1136 ;;
1280 *) 1137 *)
1325check_license() { 1182check_license() {
1326 local lic=$1 1183 local lic=$1
1327 if [ -z "${lic}" ] ; then 1184 if [ -z "${lic}" ] ; then
1328 lic="${PORTDIR}/licenses/${LICENSE}" 1185 lic="${PORTDIR}/licenses/${LICENSE}"
1329 else 1186 else
1330 if [ -e "${PORTDIR}/licenses/${src}" ] ; then 1187 if [ -e "${PORTDIR}/licenses/${lic}" ] ; then
1331 lic="${PORTDIR}/licenses/${src}" 1188 lic="${PORTDIR}/licenses/${lic}"
1332 elif [ -e "${PWD}/${src}" ] ; then 1189 elif [ -e "${PWD}/${lic}" ] ; then
1333 lic="${PWD}/${src}" 1190 lic="${PWD}/${lic}"
1334 elif [ -e "${src}" ] ; then 1191 elif [ -e "${lic}" ] ; then
1335 lic="${src}" 1192 lic="${lic}"
1336 fi
1337 fi 1193 fi
1194 fi
1338 [ ! -f "${lic}" ] && die "Could not find requested license ${src}" 1195 [ ! -f "${lic}" ] && die "Could not find requested license ${lic}"
1339 local l="`basename ${lic}`" 1196 local l="`basename ${lic}`"
1340 1197
1341 # here is where we check for the licenses the user already 1198 # here is where we check for the licenses the user already
1342 # accepted ... if we don't find a match, we make the user accept 1199 # accepted ... if we don't find a match, we make the user accept
1343 local shopts=$- 1200 local shopts=$-
1399 # first we figure out how many cds we're dealing with by 1256 # first we figure out how many cds we're dealing with by
1400 # the # of files they gave us 1257 # the # of files they gave us
1401 local cdcnt=0 1258 local cdcnt=0
1402 local f= 1259 local f=
1403 for f in "$@" ; do 1260 for f in "$@" ; do
1404 cdcnt=$((cdcnt + 1)) 1261 ((++cdcnt))
1405 export CDROM_CHECK_${cdcnt}="$f" 1262 export CDROM_CHECK_${cdcnt}="$f"
1406 done 1263 done
1407 export CDROM_TOTAL_CDS=${cdcnt} 1264 export CDROM_TOTAL_CDS=${cdcnt}
1408 export CDROM_CURRENT_CD=1 1265 export CDROM_CURRENT_CD=1
1409 1266
1410 # now we see if the user gave use CD_ROOT ... 1267 # now we see if the user gave use CD_ROOT ...
1411 # if they did, let's just believe them that it's correct 1268 # if they did, let's just believe them that it's correct
1412 if [[ ! -z ${CD_ROOT} ]] ; then
1413 export CDROM_ROOT=${CD_ROOT}
1414 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1415 return
1416 fi
1417 # do the same for CD_ROOT_X
1418 if [[ ! -z ${CD_ROOT_1} ]] ; then 1269 if [[ -n ${CD_ROOT}${CD_ROOT_1} ]] ; then
1419 local var= 1270 local var=
1420 cdcnt=0 1271 cdcnt=0
1421 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do 1272 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1422 cdcnt=$((cdcnt + 1)) 1273 ((++cdcnt))
1423 var="CD_ROOT_${cdcnt}" 1274 var="CD_ROOT_${cdcnt}"
1275 [[ -z ${!var} ]] && var="CD_ROOT"
1424 if [[ -z ${!var} ]] ; then 1276 if [[ -z ${!var} ]] ; then
1425 eerror "You must either use just the CD_ROOT" 1277 eerror "You must either use just the CD_ROOT"
1426 eerror "or specify ALL the CD_ROOT_X variables." 1278 eerror "or specify ALL the CD_ROOT_X variables."
1427 eerror "In this case, you will need ${CDROM_TOTAL_CDS} CD_ROOT_X variables." 1279 eerror "In this case, you will need ${CDROM_TOTAL_CDS} CD_ROOT_X variables."
1428 die "could not locate CD_ROOT_${cdcnt}" 1280 die "could not locate CD_ROOT_${cdcnt}"
1429 fi 1281 fi
1430 export CDROM_ROOTS_${cdcnt}="${!var}"
1431 done 1282 done
1432 export CDROM_ROOT=${CDROM_ROOTS_1} 1283 export CDROM_ROOT=${CD_ROOT_1:-${CD_ROOT}}
1433 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}" 1284 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1285 export CDROM_SET=-1
1286 for f in ${CDROM_CHECK_1//:/ } ; do
1287 ((++CDROM_SET))
1288 [[ -e ${CD_ROOT}/${f} ]] && break
1289 done
1290 export CDROM_MATCH=${f}
1434 return 1291 return
1435 fi 1292 fi
1436 1293
1294 # User didn't help us out so lets make sure they know they can
1295 # simplify the whole process ...
1437 if [[ ${CDROM_TOTAL_CDS} -eq 1 ]] ; then 1296 if [[ ${CDROM_TOTAL_CDS} -eq 1 ]] ; then
1438 einfon "This ebuild will need the " 1297 einfo "This ebuild will need the ${CDROM_NAME:-cdrom for ${PN}}"
1439 if [[ -z ${CDROM_NAME} ]] ; then
1440 echo "cdrom for ${PN}."
1441 else
1442 echo "${CDROM_NAME}."
1443 fi
1444 echo 1298 echo
1445 einfo "If you do not have the CD, but have the data files" 1299 einfo "If you do not have the CD, but have the data files"
1446 einfo "mounted somewhere on your filesystem, just export" 1300 einfo "mounted somewhere on your filesystem, just export"
1447 einfo "the variable CD_ROOT so that it points to the" 1301 einfo "the variable CD_ROOT so that it points to the"
1448 einfo "directory containing the files." 1302 einfo "directory containing the files."
1452 echo 1306 echo
1453 else 1307 else
1454 einfo "This package will need access to ${CDROM_TOTAL_CDS} cds." 1308 einfo "This package will need access to ${CDROM_TOTAL_CDS} cds."
1455 cdcnt=0 1309 cdcnt=0
1456 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do 1310 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1457 cdcnt=$((cdcnt + 1)) 1311 ((++cdcnt))
1458 var="CDROM_NAME_${cdcnt}" 1312 var="CDROM_NAME_${cdcnt}"
1459 [[ ! -z ${!var} ]] && einfo " CD ${cdcnt}: ${!var}" 1313 [[ ! -z ${!var} ]] && einfo " CD ${cdcnt}: ${!var}"
1460 done 1314 done
1461 echo 1315 echo
1462 einfo "If you do not have the CDs, but have the data files" 1316 einfo "If you do not have the CDs, but have the data files"
1463 einfo "mounted somewhere on your filesystem, just export" 1317 einfo "mounted somewhere on your filesystem, just export"
1464 einfo "the following variables so they point to the right place:" 1318 einfo "the following variables so they point to the right place:"
1465 einfon "" 1319 einfon ""
1466 cdcnt=0 1320 cdcnt=0
1467 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do 1321 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1468 cdcnt=$((cdcnt + 1)) 1322 ((++cdcnt))
1469 echo -n " CD_ROOT_${cdcnt}" 1323 echo -n " CD_ROOT_${cdcnt}"
1470 done 1324 done
1471 echo 1325 echo
1472 einfo "Or, if you have all the files in the same place, or" 1326 einfo "Or, if you have all the files in the same place, or"
1473 einfo "you only have one cdrom, you can export CD_ROOT" 1327 einfo "you only have one cdrom, you can export CD_ROOT"
1476 echo 1330 echo
1477 einfo "For example:" 1331 einfo "For example:"
1478 einfo "export CD_ROOT_1=/mnt/cdrom" 1332 einfo "export CD_ROOT_1=/mnt/cdrom"
1479 echo 1333 echo
1480 fi 1334 fi
1335
1336 export CDROM_SET=""
1481 export CDROM_CURRENT_CD=0 1337 export CDROM_CURRENT_CD=0
1482 cdrom_load_next_cd 1338 cdrom_load_next_cd
1483} 1339}
1484 1340
1485# this is only used when you need access to more than one cd. 1341# this is only used when you need access to more than one cd.
1486# when you have finished using the first cd, just call this function. 1342# when you have finished using the first cd, just call this function.
1487# when it returns, CDROM_ROOT will be pointing to the second cd. 1343# when it returns, CDROM_ROOT will be pointing to the second cd.
1488# remember, you can only go forward in the cd chain, you can't go back. 1344# remember, you can only go forward in the cd chain, you can't go back.
1489cdrom_load_next_cd() { 1345cdrom_load_next_cd() {
1490 export CDROM_CURRENT_CD=$((CDROM_CURRENT_CD + 1))
1491 local var= 1346 local var
1492 1347 ((++CDROM_CURRENT_CD))
1493 if [[ ! -z ${CD_ROOT} ]] ; then
1494 einfo "Using same root as before for CD #${CDROM_CURRENT_CD}"
1495 return
1496 fi
1497 1348
1498 unset CDROM_ROOT 1349 unset CDROM_ROOT
1499 var=CDROM_ROOTS_${CDROM_CURRENT_CD} 1350 var=CD_ROOT_${CDROM_CURRENT_CD}
1351 [[ -z ${!var} ]] && var="CD_ROOT"
1500 if [[ -z ${!var} ]] ; then 1352 if [[ -z ${!var} ]] ; then
1501 var="CDROM_CHECK_${CDROM_CURRENT_CD}" 1353 var="CDROM_CHECK_${CDROM_CURRENT_CD}"
1502 cdrom_locate_file_on_cd ${!var} 1354 _cdrom_locate_file_on_cd ${!var}
1503 else 1355 else
1504 export CDROM_ROOT=${!var} 1356 export CDROM_ROOT=${!var}
1505 fi 1357 fi
1506 1358
1507 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}" 1359 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1512# all it does is try to locate a give file on a cd ... if the cd isn't 1364# all it does is try to locate a give file on a cd ... if the cd isn't
1513# found, then a message asking for the user to insert the cdrom will be 1365# found, then a message asking for the user to insert the cdrom will be
1514# displayed and we'll hang out here until: 1366# displayed and we'll hang out here until:
1515# (1) the file is found on a mounted cdrom 1367# (1) the file is found on a mounted cdrom
1516# (2) the user hits CTRL+C 1368# (2) the user hits CTRL+C
1517cdrom_locate_file_on_cd() { 1369_cdrom_locate_file_on_cd() {
1370 local mline=""
1371 local showedmsg=0
1372
1518 while [[ -z ${CDROM_ROOT} ]] ; do 1373 while [[ -z ${CDROM_ROOT} ]] ; do
1374 local i=0
1375 local -a cdset=(${*//:/ })
1376 if [[ -n ${CDROM_SET} ]] ; then
1377 cdset=(${cdset[${CDROM_SET}]})
1378 fi
1379
1380 while [[ -n ${cdset[${i}]} ]] ; do
1519 local dir="$(dirname ${@})" 1381 local dir=$(dirname ${cdset[${i}]})
1520 local file="$(basename ${@})" 1382 local file=$(basename ${cdset[${i}]})
1521 local mline=""
1522 local showedmsg=0
1523 1383
1524 for mline in $(mount | egrep -e '(iso|cdrom)' | awk '{print $3}') ; do 1384 for mline in $(mount | gawk '/(iso|cdrom|fs=cdfss)/ {print $3}') ; do
1525 [[ -d ${mline}/${dir} ]] || continue 1385 [[ -d ${mline}/${dir} ]] || continue
1526 [[ ! -z $(find ${mline}/${dir} -iname ${file} -maxdepth 1) ]] \ 1386 if [[ -n $(find ${mline}/${dir} -maxdepth 1 -iname ${file}) ]] ; then
1527 && export CDROM_ROOT=${mline} 1387 export CDROM_ROOT=${mline}
1388 export CDROM_SET=${i}
1389 export CDROM_MATCH=${cdset[${i}]}
1390 return
1391 fi
1392 done
1393
1394 ((++i))
1528 done 1395 done
1529 1396
1530 if [[ -z ${CDROM_ROOT} ]] ; then
1531 echo 1397 echo
1532 if [[ ${showedmsg} -eq 0 ]] ; then 1398 if [[ ${showedmsg} -eq 0 ]] ; then
1533 if [[ ${CDROM_TOTAL_CDS} -eq 1 ]] ; then 1399 if [[ ${CDROM_TOTAL_CDS} -eq 1 ]] ; then
1534 if [[ -z ${CDROM_NAME} ]] ; then 1400 if [[ -z ${CDROM_NAME} ]] ; then
1535 einfo "Please insert the cdrom for ${PN} now !" 1401 einfo "Please insert+mount the cdrom for ${PN} now !"
1536 else
1537 einfo "Please insert the ${CDROM_NAME} cdrom now !"
1538 fi
1539 else 1402 else
1540 if [[ -z ${CDROM_NAME_1} ]] ; then
1541 einfo "Please insert cd #${CDROM_CURRENT_CD} for ${PN} now !"
1542 else
1543 local var="CDROM_NAME_${CDROM_CURRENT_CD}"
1544 einfo "Please insert+mount the ${!var} cdrom now !" 1403 einfo "Please insert+mount the ${CDROM_NAME} cdrom now !"
1545 fi
1546 fi 1404 fi
1547 showedmsg=1 1405 else
1406 if [[ -z ${CDROM_NAME_1} ]] ; then
1407 einfo "Please insert+mount cd #${CDROM_CURRENT_CD} for ${PN} now !"
1408 else
1409 local var="CDROM_NAME_${CDROM_CURRENT_CD}"
1410 einfo "Please insert+mount the ${!var} cdrom now !"
1411 fi
1548 fi 1412 fi
1413 showedmsg=1
1414 fi
1549 einfo "Press return to scan for the cd again" 1415 einfo "Press return to scan for the cd again"
1550 einfo "or hit CTRL+C to abort the emerge." 1416 einfo "or hit CTRL+C to abort the emerge."
1551 read 1417 echo
1552 fi 1418 einfo "If you are having trouble with the detection"
1419 einfo "of your CD, it is possible that you do not have"
1420 einfo "Joliet support enabled in your kernel. Please"
1421 einfo "check that CONFIG_JOLIET is enabled in your kernel."
1422 read || die "something is screwed with your system"
1553 done 1423 done
1554} 1424}
1555 1425
1556# Make sure that LINGUAS only contains languages that 1426# Make sure that LINGUAS only contains languages that
1557# a package can support 1427# a package can support
1599 else 1469 else
1600 ewarn "Sorry, but ${PN} does not support the ${f} LINGUA" 1470 ewarn "Sorry, but ${PN} does not support the ${f} LINGUA"
1601 fi 1471 fi
1602 done 1472 done
1603 if [[ -z ${newls} ]] ; then 1473 if [[ -z ${newls} ]] ; then
1604 unset LINGUAS 1474 export LINGUAS=""
1605 else 1475 else
1606 export LINGUAS=${newls:1} 1476 export LINGUAS=${newls:1}
1607 fi 1477 fi
1608} 1478}
1609 1479
1619 while ((i--)) ; do 1489 while ((i--)) ; do
1620 ewarn "PLEASE UPDATE TO YOUR PACKAGE TO USE linux-info.eclass" 1490 ewarn "PLEASE UPDATE TO YOUR PACKAGE TO USE linux-info.eclass"
1621 done 1491 done
1622 export EUTILS_ECLASS_PORTAGE_ARCH="${ARCH}" 1492 export EUTILS_ECLASS_PORTAGE_ARCH="${ARCH}"
1623 case ${ARCH} in 1493 case ${ARCH} in
1624 x86) export ARCH="i386";; 1494 x86) export ARCH="i386";;
1625 amd64) export ARCH="x86_64";; 1495 amd64) export ARCH="x86_64";;
1626 hppa) export ARCH="parisc";; 1496 hppa) export ARCH="parisc";;
1627 mips) export ARCH="mips";; 1497 mips) export ARCH="mips";;
1628 sparc) export ARCH="$(tc-arch-kernel)";; # Yeah this is ugly, but it's even WORSE if you don't do this. linux-info.eclass's set_arch_to_kernel is fixed, but won't get used over this one! 1498 sparc) export ARCH="$(tc-arch-kernel)";; # Yeah this is ugly, but it's even WORSE if you don't do this. linux-info.eclass's set_arch_to_kernel is fixed, but won't get used over this one!
1629 *) export ARCH="${ARCH}";; 1499 *) export ARCH="${ARCH}";;
1630 esac 1500 esac
1631} 1501}
1632 1502
1633# set's ARCH back to what portage expects 1503# set's ARCH back to what portage expects
1634set_arch_to_portage() { 1504set_arch_to_portage() {
1678 LIB=$1 1548 LIB=$1
1679 1549
1680 if [ -n "${LIB}" -a -f "${ROOT}${LIB}" ]; then 1550 if [ -n "${LIB}" -a -f "${ROOT}${LIB}" ]; then
1681 SONAME=`basename ${LIB}` 1551 SONAME=`basename ${LIB}`
1682 1552
1683 einfo "An old version of an installed library was detected on your system." 1553 ewarn "An old version of an installed library was detected on your system."
1684 einfo "In order to avoid breaking packages that link against is, this older version" 1554 ewarn "In order to avoid breaking packages that link against it, this older version"
1685 einfo "is not being removed. In order to make full use of this newer version," 1555 ewarn "is not being removed. In order to make full use of this newer version,"
1686 einfo "you will need to execute the following command:" 1556 ewarn "you will need to execute the following command:"
1687 einfo " revdep-rebuild --soname ${SONAME}" 1557 ewarn " revdep-rebuild --soname ${SONAME}"
1688 einfo 1558 ewarn
1689 einfo "After doing that, you can safely remove ${LIB}" 1559 ewarn "After doing that, you can safely remove ${LIB}"
1690 einfo "Note: 'emerge gentoolkit' to get revdep-rebuild" 1560 ewarn "Note: 'emerge gentoolkit' to get revdep-rebuild"
1691 fi 1561 fi
1692} 1562}
1693 1563
1694# Hack for people to figure out if a package was built with 1564# Hack for people to figure out if a package was built with
1695# certain USE flags 1565# certain USE flags
1705 [[ ${opt:0:1} = "-" ]] && shift || opt="-a" 1575 [[ ${opt:0:1} = "-" ]] && shift || opt="-a"
1706 1576
1707 local PKG=$(best_version $1) 1577 local PKG=$(best_version $1)
1708 shift 1578 shift
1709 1579
1710 local USEFILE="${ROOT}/var/db/pkg/${PKG}/USE" 1580 local USEFILE=${ROOT}/var/db/pkg/${PKG}/USE
1581
1582 # if the USE file doesnt exist, assume the $PKG is either
1583 # injected or package.provided
1711 [[ ! -e ${USEFILE} ]] && return 1 1584 [[ ! -e ${USEFILE} ]] && return 0
1712 1585
1713 local USE_BUILT=$(<${USEFILE}) 1586 local USE_BUILT=$(<${USEFILE})
1714 while [[ $# -gt 0 ]] ; do 1587 while [[ $# -gt 0 ]] ; do
1715 if [[ ${opt} = "-o" ]] ; then 1588 if [[ ${opt} = "-o" ]] ; then
1716 has $1 ${USE_BUILT} && return 0 1589 has $1 ${USE_BUILT} && return 0
1741dopamd() { 1614dopamd() {
1742 [[ -z $1 ]] && die "dopamd requires at least one argument" 1615 [[ -z $1 ]] && die "dopamd requires at least one argument"
1743 1616
1744 use pam || return 0 1617 use pam || return 0
1745 1618
1746 insinto /etc/pam.d 1619 INSDESTTREE=/etc/pam.d \
1747 doins "$@" || die "failed to install $@" 1620 doins "$@" || die "failed to install $@"
1748} 1621}
1749# newpamd <old name> <new name> 1622# newpamd <old name> <new name>
1750# 1623#
1751# Install pam file <old name> as <new name> in /etc/pam.d 1624# Install pam file <old name> as <new name> in /etc/pam.d
1752newpamd() { 1625newpamd() {
1753 [[ $# -ne 2 ]] && die "newpamd requires two arguements" 1626 [[ $# -ne 2 ]] && die "newpamd requires two arguements"
1754 1627
1755 use pam || return 0 1628 use pam || return 0
1756 1629
1757 insinto /etc/pam.d 1630 INSDESTTREE=/etc/pam.d \
1758 newins "$1" "$2" || die "failed to install $1 as $2" 1631 newins "$1" "$2" || die "failed to install $1 as $2"
1759} 1632}
1760 1633
1761# make a wrapper script ... 1634# make a wrapper script ...
1762# NOTE: this was originally games_make_wrapper, but I noticed other places where 1635# NOTE: this was originally games_make_wrapper, but I noticed other places where
1764# -- wolf31o2 1637# -- wolf31o2
1765# $1 == wrapper name 1638# $1 == wrapper name
1766# $2 == binary to run 1639# $2 == binary to run
1767# $3 == directory to chdir before running binary 1640# $3 == directory to chdir before running binary
1768# $4 == extra LD_LIBRARY_PATH's (make it : delimited) 1641# $4 == extra LD_LIBRARY_PATH's (make it : delimited)
1642# $5 == path for wrapper
1769make_wrapper() { 1643make_wrapper() {
1770 local wrapper=$1 bin=$2 chdir=$3 libdir=$4 1644 local wrapper=$1 bin=$2 chdir=$3 libdir=$4 path=$5
1771 local tmpwrapper=$(emktemp) 1645 local tmpwrapper=$(emktemp)
1646 # We don't want to quote ${bin} so that people can pass complex
1647 # things as $bin ... "./someprog --args"
1772 cat << EOF > "${tmpwrapper}" 1648 cat << EOF > "${tmpwrapper}"
1773#!/bin/sh 1649#!/bin/sh
1774cd "${chdir}" 1650cd "${chdir:-.}"
1651if [ -n "${libdir}" ] ; then
1652 if [ "\${LD_LIBRARY_PATH+set}" = "set" ] ; then
1775export LD_LIBRARY_PATH="\${LD_LIBRARY_PATH}:${libdir}" 1653 export LD_LIBRARY_PATH="\${LD_LIBRARY_PATH}:${libdir}"
1654 else
1655 export LD_LIBRARY_PATH="${libdir}"
1656 fi
1657fi
1776exec ${bin} "\$@" 1658exec ${bin} "\$@"
1777EOF 1659EOF
1778 chmod go+rx "${tmpwrapper}" 1660 chmod go+rx "${tmpwrapper}"
1661 if [[ -n ${path} ]] ; then
1662 exeinto "${path}"
1663 newexe "${tmpwrapper}" "${wrapper}"
1664 else
1779 newbin "${tmpwrapper}" "${wrapper}" 1665 newbin "${tmpwrapper}" "${wrapper}"
1666 fi
1780} 1667}

Legend:
Removed from v.1.162  
changed lines
  Added in v.1.223

  ViewVC Help
Powered by ViewVC 1.1.20